#include "common.h"
#include "debug.h"
					
struct s_vcard *parse_vcard (char *vCard) {
	struct s_vcard *vCresult;
	struct s_result rxpresult;
	vCresult = calloc (sizeof(struct s_vcard),1);

	pmesg(100, "-----------------------------------------------------\n");
	pmesg(100, "%s\n", vCard);
	pmesg(100, "-----------------------------------------------------\n");

	rxpresult = rxp("REV:(\\d{4})(\\d{2})(\\d{2})T(\\d{2})(\\d{2})(\\d{2})\r\n", vCard);
	vCresult->last_mod.year = atoi(rxpresult.result[1]);
	vCresult->last_mod.month = atoi(rxpresult.result[2]);
	vCresult->last_mod.day = atoi(rxpresult.result[3]);
	vCresult->last_mod.hour = atoi(rxpresult.result[4]);
	vCresult->last_mod.min = atoi(rxpresult.result[5]);
    vCresult->last_mod.sec = atoi(rxpresult.result[6]);

	/* Names may consist of 'last;first', but when only one of those is
	 * specified, the ; will fall out, and only one 'name' will appear
	 * for this we need another check. */
	rxpresult = rxp("\nN:(.*)\r\n", vCard);
	if (rxpresult.elemcount >= 1) {
		if (strstr(rxpresult.result[1], ";")) { /* Consists of last;first */
			rxpresult = rxp("(.*);(.*)", rxpresult.result[1]);
			strncpy(vCresult->lastname, rxpresult.result[1], strlen(rxpresult.result[1]));
			strncpy(vCresult->firstname, rxpresult.result[2], strlen(rxpresult.result[2]));
		} else { /* Consists of only one of them */
			strncpy(vCresult->lastname, rxpresult.result[1], strlen(rxpresult.result[1]));
		}
	}
	vCresult->lastname[strlen(vCresult->lastname)+1] = 0; strip(vCresult->lastname);
	vCresult->firstname[strlen(vCresult->firstname)+1] = 0; strip(vCresult->firstname);
		
	rxpresult = rxp("ADR:;;(.*);(.*);;(.*);(.*)\r\n", vCard);
	if (rxpresult.elemcount >= 1) {
		strncpy(vCresult->street, rxpresult.result[1], strlen(rxpresult.result[1]));
		vCresult->street[strlen(vCresult->street)+1] = 0; strip(vCresult->street);
		strncpy(vCresult->city, rxpresult.result[2], strlen(rxpresult.result[2]));
		vCresult->city[strlen(vCresult->city)+1] = 0; strip(vCresult->city);
		strncpy(vCresult->postal, rxpresult.result[3], strlen(rxpresult.result[3]));
		vCresult->postal[strlen(vCresult->postal)+1] = 0; strip(vCresult->postal);
		strncpy(vCresult->country, rxpresult.result[4], strlen(rxpresult.result[4]));
		vCresult->country[strlen(vCresult->country)+1] = 0; strip(vCresult->country);
	}

	rxpresult = rxp("ORG:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->organisation, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->organisation[strlen(vCresult->organisation)+1] = 0; strip(vCresult->organisation);

	rxpresult = rxp("TEL;HOME:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->home, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->home[strlen(vCresult->home)+1] = 0; strip(vCresult->home);

	rxpresult = rxp("TEL;CELL:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->cell, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->cell[strlen(vCresult->cell)+1] = 0; strip(vCresult->cell);

	rxpresult = rxp("TEL;WORK:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->work, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->work[strlen(vCresult->work)+1] = 0; strip(vCresult->work);

	rxpresult = rxp("TEL;FAX:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->fax, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->fax[strlen(vCresult->fax)+1] = 0; strip(vCresult->fax);

	rxpresult = rxp("EMAIL;INTERNET:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->email, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->email[strlen(vCresult->email)+1] = 0; strip(vCresult->email);

	rxpresult = rxp("URL:(.*)\n", vCard);
	if (rxpresult.elemcount >= 1)
		strncpy(vCresult->url, rxpresult.result[1], strlen(rxpresult.result[1]));
	vCresult->url[strlen(vCresult->url)+1] = 0; strip(vCresult->url);

	return vCresult;
}
